import { MostlyVNode } from './';
export function elementToVNode(element) {
    return new MostlyVNode(element.tagName && element.tagName.toLowerCase(), {
        id: element.id,
        className: element.className
    }, Array.prototype.slice.call(element.childNodes).map(nodeToVNode) || undefined, element, undefined, undefined, undefined, undefined);
}
function nodeToVNode(node) {
    if (isElement(node))
        return elementToVNode(node);
    var textVNode = MostlyVNode.createText(node.textContent);
    textVNode.element = node;
    return textVNode;
}
function isElement(node) {
    return node.nodeType === 1;
}
//# sourceMappingURL=elementToVNode.js.map