var classIdSplit = /([\.#]?[a-zA-Z0-9\u007F-\uFFFF_:-]+)/;
export function parseSelector(selector) {
    var tagName;
    var id = '';
    var classes = [];
    var tagParts = selector.split(classIdSplit);
    var part;
    var type;
    for (var i = 0; i < tagParts.length; i++) {
        part = tagParts[i];
        if (!part)
            continue;
        type = part.charAt(0);
        if (!tagName) {
            tagName = part;
        }
        else if (type === '.') {
            classes.push(part.substring(1, part.length));
        }
        else if (type === '#') {
            id = part.substring(1, part.length);
        }
    }
    return {
        tagName: tagName,
        id: id,
        className: classes.join(' '),
    };
}
//# sourceMappingURL=parseSelector.js.map