import { hasCssSelector } from './hasCssSelector';
export var querySelector = (function (cssSelector, vNode) { return vNode
    ? _querySelector(cssSelector, vNode)
    : function (_vNode) { return _querySelector(cssSelector, _vNode); }; });
function _querySelector(cssSelector, vNode) {
    var scope = vNode.scope;
    var children = [vNode];
    while (children.length > 0) {
        var child = children.shift();
        if (child.scope !== scope)
            continue;
        if (hasCssSelector(cssSelector, child))
            return child;
        if (!child.children)
            continue;
        children.push.apply(children, child.children);
    }
    return null;
}
//# sourceMappingURL=querySelector.js.map