"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require("./");
function elementToVNode(element) {
    return new _1.MostlyVNode(element.tagName && element.tagName.toLowerCase(), {
        id: element.id,
        className: element.className
    }, Array.prototype.slice.call(element.childNodes).map(nodeToVNode) || undefined, element, undefined, undefined, undefined, undefined);
}
exports.elementToVNode = elementToVNode;
function nodeToVNode(node) {
    if (isElement(node))
        return elementToVNode(node);
    var textVNode = _1.MostlyVNode.createText(node.textContent);
    textVNode.element = node;
    return textVNode;
}
function isElement(node) {
    return node.nodeType === 1;
}
//# sourceMappingURL=elementToVNode.js.map