import { HtmlTagNames, VNode, VNodeEvents, VNodeProps } from '../';
import { HTMLAnchorElementProperties, HTMLAppletElementProperties, HTMLAreaElementProperties, HTMLAudioElementProperties, HTMLBRElementProperties, HTMLBaseElementProperties, HTMLBaseFontElementProperties, HTMLBodyElementProperties, HTMLButtonElementProperties, HTMLCanvasElementProperties, HTMLDListElementProperties, HTMLDataElementProperties, HTMLDataListElementProperties, HTMLDirectoryElementProperties, HTMLDivElementProperties, HTMLEmbedElementProperties, HTMLFieldSetElementProperties, HTMLFontElementProperties, HTMLFormElementProperties, HTMLFrameElementProperties, HTMLFrameSetElementProperties, HTMLHRElementProperties, HTMLHeadElementProperties, HTMLHeadingElementProperties, HTMLHtmlElementProperties, HTMLIFrameElementProperties, HTMLImageElementProperties, HTMLInputElementProperties, HTMLLIElementProperties, HTMLLabelElementProperties, HTMLLegendElementProperties, HTMLLinkElementProperties, HTMLMapElementProperties, HTMLMarqueeElementProperties, HTMLMenuElementProperties, HTMLMetaElementProperties, HTMLMeterElementProperties, HTMLOListElementProperteis, HTMLObjectElementProperties, HTMLOptGroupElementProperties, HTMLOptionElementProperties, HTMLOutputElementProperties, HTMLParagraphElementProperties, HTMLParamElementProperties, HTMLPictureElementProperties, HTMLPreElementProperties, HTMLProgressElementProperties, HTMLQuoteElementProperties, HTMLScriptElementProperties, HTMLSelectElementProperties, HTMLSourceElementProperties, HTMLSpanElementProperties, HTMLStyleElementProperties, HTMLTableElementProperties, HTMLTableRowElementProperties, HTMLTemplateElementProperties, HTMLTextAreaElementProperties, HTMLTimeElementProperties, HTMLTitleElementProperties, HTMLTrackElementProperties, HTMLUListElementProperties, HTMLVideoElementProperties } from '../types/HtmlProperties';
import { HyperscriptChildren } from './h';
export interface HyperscriptHelperFn<T extends Element, Props extends VNodeProps<T> = VNodeProps<T>> {
    (): VNode<T, Props>;
    (data: Props): VNode<T, Props & VNodeProps<T>>;
    (data: Props, children: HyperscriptChildren): VNode<T, Props>;
    (children: HyperscriptChildren): VNode<T, Props>;
}
export declare function hh<T extends HTMLElement, Props extends VNodeProps<T> = VNodeProps<T>>(tagName: HtmlTagNames): HyperscriptHelperFn<T, Props>;
export declare const a: HyperscriptHelperFn<HTMLAnchorElement, HTMLAnchorElementProperties>;
export declare const abbr: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const acronym: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const address: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const applet: HyperscriptHelperFn<HTMLAppletElement, HTMLAppletElementProperties>;
export declare const area: HyperscriptHelperFn<HTMLAreaElement, HTMLAreaElementProperties>;
export declare const article: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const aside: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const audio: HyperscriptHelperFn<HTMLAudioElement, HTMLAudioElementProperties>;
export declare const b: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const base: HyperscriptHelperFn<HTMLBaseElement, HTMLBaseElementProperties>;
export declare const basefont: HyperscriptHelperFn<HTMLBaseFontElement, HTMLBaseFontElementProperties>;
export declare const bdi: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const bdo: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const bgsound: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const big: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const blink: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const blockquote: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const body: HyperscriptHelperFn<HTMLBodyElement, HTMLBodyElementProperties>;
export declare const br: HyperscriptHelperFn<HTMLBRElement, HTMLBRElementProperties>;
export declare const button: HyperscriptHelperFn<HTMLButtonElement, HTMLButtonElementProperties>;
export declare const canvas: HyperscriptHelperFn<HTMLCanvasElement, HTMLCanvasElementProperties>;
export declare const caption: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const center: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const cite: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const code: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const col: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const colgroup: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const command: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const content: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const data: HyperscriptHelperFn<HTMLDataElement, HTMLDataElementProperties>;
export declare const datalist: HyperscriptHelperFn<HTMLDataListElement, HTMLDataListElementProperties>;
export declare const dd: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const del: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const details: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const dfn: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const dialog: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const dir: HyperscriptHelperFn<HTMLDirectoryElement, HTMLDirectoryElementProperties>;
export declare const div: HyperscriptHelperFn<HTMLDivElement, HTMLDivElementProperties>;
export declare const dl: HyperscriptHelperFn<HTMLDListElement, HTMLDListElementProperties>;
export declare const dt: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const element: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const em: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const embed: HyperscriptHelperFn<HTMLEmbedElement, HTMLEmbedElementProperties>;
export declare const fieldset: HyperscriptHelperFn<HTMLFieldSetElement, HTMLFieldSetElementProperties>;
export declare const figcaption: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const figure: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const font: HyperscriptHelperFn<HTMLFontElement, HTMLFontElementProperties>;
export declare const form: HyperscriptHelperFn<HTMLFormElement, HTMLFormElementProperties>;
export declare const footer: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const frame: HyperscriptHelperFn<HTMLFrameElement, HTMLFrameElementProperties>;
export declare const frameset: HyperscriptHelperFn<HTMLFrameSetElement, HTMLFrameSetElementProperties>;
export declare const h1: HyperscriptHelperFn<HTMLHeadingElement, HTMLHeadingElementProperties>;
export declare const h2: HyperscriptHelperFn<HTMLHeadingElement, HTMLHeadingElementProperties>;
export declare const h3: HyperscriptHelperFn<HTMLHeadingElement, HTMLHeadingElementProperties>;
export declare const h4: HyperscriptHelperFn<HTMLHeadingElement, HTMLHeadingElementProperties>;
export declare const h5: HyperscriptHelperFn<HTMLHeadingElement, HTMLHeadingElementProperties>;
export declare const h6: HyperscriptHelperFn<HTMLHeadingElement, HTMLHeadingElementProperties>;
export declare const head: HyperscriptHelperFn<HTMLHeadElement, HTMLHeadElementProperties>;
export declare const header: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const hgroup: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const hr: HyperscriptHelperFn<HTMLHRElement, HTMLHRElementProperties>;
export declare const html: HyperscriptHelperFn<HTMLHtmlElement, HTMLHtmlElementProperties>;
export declare const i: HyperscriptHelperFn<HTMLHtmlElement, HTMLHtmlElementProperties>;
export declare const iframe: HyperscriptHelperFn<HTMLIFrameElement, HTMLIFrameElementProperties>;
export declare const img: HyperscriptHelperFn<HTMLImageElement, HTMLImageElementProperties>;
export declare const input: HyperscriptHelperFn<HTMLInputElement, HTMLInputElementProperties>;
export declare const ins: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const isindex: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const kbd: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const keygen: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const label: HyperscriptHelperFn<HTMLLabelElement, HTMLLabelElementProperties>;
export declare const legend: HyperscriptHelperFn<HTMLLegendElement, HTMLLegendElementProperties>;
export declare const li: HyperscriptHelperFn<HTMLLIElement, HTMLLIElementProperties>;
export declare const link: HyperscriptHelperFn<HTMLLinkElement, HTMLLinkElementProperties>;
export declare const listing: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const main: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const map: HyperscriptHelperFn<HTMLMapElement, HTMLMapElementProperties>;
export declare const mark: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const marquee: HyperscriptHelperFn<HTMLMarqueeElement, HTMLMarqueeElementProperties>;
export declare const math: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const menu: HyperscriptHelperFn<HTMLMenuElement, HTMLMenuElementProperties>;
export declare const menuitem: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const meta: HyperscriptHelperFn<HTMLMetaElement, HTMLMetaElementProperties>;
export declare const meter: HyperscriptHelperFn<HTMLMeterElement, HTMLMeterElementProperties>;
export declare const multicol: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const nav: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const nextid: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const nobr: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const noembed: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const noframes: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const noscript: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const object: HyperscriptHelperFn<HTMLObjectElement, HTMLObjectElementProperties>;
export declare const ol: HyperscriptHelperFn<HTMLOListElement, HTMLOListElementProperteis>;
export declare const optgroup: HyperscriptHelperFn<HTMLOptGroupElement, HTMLOptGroupElementProperties>;
export declare const option: HyperscriptHelperFn<HTMLOptionElement, HTMLOptionElementProperties>;
export declare const output: HyperscriptHelperFn<HTMLOutputElement, HTMLOutputElementProperties>;
export declare const p: HyperscriptHelperFn<HTMLParagraphElement, HTMLParagraphElementProperties>;
export declare const param: HyperscriptHelperFn<HTMLParamElement, HTMLParamElementProperties>;
export declare const picture: HyperscriptHelperFn<HTMLPictureElement, HTMLPictureElementProperties>;
export declare const plaintext: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const pre: HyperscriptHelperFn<HTMLPreElement, HTMLPreElementProperties>;
export declare const progress: HyperscriptHelperFn<HTMLProgressElement, HTMLProgressElementProperties>;
export declare const q: HyperscriptHelperFn<HTMLQuoteElement, HTMLQuoteElementProperties>;
export declare const rb: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const rbc: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const rp: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const rt: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const rtc: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const ruby: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const s: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const samp: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const script: HyperscriptHelperFn<HTMLScriptElement, HTMLScriptElementProperties>;
export declare const section: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const select: HyperscriptHelperFn<HTMLSelectElement, HTMLSelectElementProperties>;
export declare const shadow: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const small: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const source: HyperscriptHelperFn<HTMLSourceElement, HTMLSourceElementProperties>;
export declare const spacer: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const span: HyperscriptHelperFn<HTMLSpanElement, HTMLSpanElementProperties>;
export declare const strike: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const strong: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const style: HyperscriptHelperFn<HTMLStyleElement, HTMLStyleElementProperties>;
export declare const sub: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const summary: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const sup: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const slot: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const table: HyperscriptHelperFn<HTMLTableElement, HTMLTableElementProperties>;
export declare const tbody: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const td: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const template: HyperscriptHelperFn<HTMLTemplateElement, HTMLTemplateElementProperties>;
export declare const textarea: HyperscriptHelperFn<HTMLTextAreaElement, HTMLTextAreaElementProperties>;
export declare const tfoot: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const th: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const time: HyperscriptHelperFn<HTMLTimeElement, HTMLTimeElementProperties>;
export declare const title: HyperscriptHelperFn<HTMLTitleElement, HTMLTitleElementProperties>;
export declare const tr: HyperscriptHelperFn<HTMLTableRowElement, HTMLTableRowElementProperties>;
export declare const track: HyperscriptHelperFn<HTMLTrackElement, HTMLTrackElementProperties>;
export declare const tt: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const u: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const ul: HyperscriptHelperFn<HTMLUListElement, HTMLUListElementProperties>;
export declare const video: HyperscriptHelperFn<HTMLVideoElement, HTMLVideoElementProperties>;
export declare const wbr: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
export declare const xmp: HyperscriptHelperFn<HTMLElement, VNodeProps<HTMLElement, VNodeEvents<HTMLElement, ElementEventMap>>>;
declare global {
    namespace JSX {
        interface Element extends VNode {
        }
        interface IntrinsicElements {
            a: HTMLAnchorElementProperties;
            applet: HTMLAppletElementProperties;
            area: HTMLAreaElementProperties;
            audio: HTMLAudioElementProperties;
            base: HTMLBaseElementProperties;
            basefont: HTMLBaseFontElementProperties;
            body: HTMLBodyElementProperties;
            br: HTMLBRElementProperties;
            button: HTMLButtonElementProperties;
            canvas: HTMLCanvasElementProperties;
            data: HTMLDataElementProperties;
            datalist: HTMLDataListElementProperties;
            dir: HTMLDirectoryElementProperties;
            div: HTMLDivElementProperties;
            dl: HTMLDListElementProperties;
            embed: HTMLEmbedElementProperties;
            fieldset: HTMLFieldSetElementProperties;
            font: HTMLFontElementProperties;
            form: HTMLFormElementProperties;
            frame: HTMLFrameElementProperties;
            frameset: HTMLFrameSetElementProperties;
            h1: HTMLHeadingElementProperties;
            h2: HTMLHeadingElementProperties;
            h3: HTMLHeadingElementProperties;
            h4: HTMLHeadingElementProperties;
            h5: HTMLHeadingElementProperties;
            h6: HTMLHeadingElementProperties;
            head: HTMLHeadElementProperties;
            hr: HTMLHRElementProperties;
            html: HTMLHtmlElementProperties;
            i: HTMLHtmlElementProperties;
            iframe: HTMLIFrameElementProperties;
            img: HTMLImageElementProperties;
            input: HTMLInputElementProperties;
            label: HTMLLabelElementProperties;
            legend: HTMLLegendElementProperties;
            li: HTMLLIElementProperties;
            link: HTMLLinkElementProperties;
            map: HTMLMapElementProperties;
            marquee: HTMLMarqueeElementProperties;
            menu: HTMLMenuElementProperties;
            meta: HTMLMetaElementProperties;
            meter: HTMLMeterElementProperties;
            object: HTMLObjectElementProperties;
            ol: HTMLOListElementProperteis;
            optgroup: HTMLOptGroupElementProperties;
            option: HTMLOptionElementProperties;
            output: HTMLOutputElementProperties;
            p: HTMLParagraphElementProperties;
            param: HTMLParamElementProperties;
            picture: HTMLPictureElementProperties;
            pre: HTMLPreElementProperties;
            progress: HTMLProgressElementProperties;
            q: HTMLQuoteElementProperties;
            script: HTMLScriptElementProperties;
            select: HTMLSelectElementProperties;
            source: HTMLSourceElementProperties;
            span: HTMLSpanElementProperties;
            style: HTMLStyleElementProperties;
            table: HTMLTableElementProperties;
            template: HTMLTemplateElementProperties;
            textarea: HTMLTextAreaElementProperties;
            time: HTMLTimeElementProperties;
            title: HTMLTitleElementProperties;
            tr: HTMLTableRowElementProperties;
            track: HTMLTrackElementProperties;
            ul: HTMLUListElementProperties;
            video: HTMLVideoElementProperties;
        }
    }
}
