"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var h_1 = require("./h");
// tslint:enable:max-line-length
function hh(tagName) {
    return function () {
        var data = arguments[0];
        var children = arguments[1];
        if (Array.isArray(data))
            return h_1.h(tagName, {}, data);
        if (typeof data === 'object')
            return h_1.h(tagName, data, children);
        return h_1.h(tagName, data || {});
    };
}
exports.hh = hh;
function isValidString(param) {
    return typeof param === 'string' && param.length > 0;
}
function isSelector(param) {
    return isValidString(param) && (param[0] === '.' || param[0] === '#');
}
exports.a = hh('a');
exports.abbr = hh('abbr');
exports.acronym = hh('acronym');
exports.address = hh('address');
exports.applet = hh('applet');
exports.area = hh('area');
exports.article = hh('article');
exports.aside = hh('aside');
exports.audio = hh('audio');
exports.b = hh('b');
exports.base = hh('base');
exports.basefont = hh('basefont');
exports.bdi = hh('bdi');
exports.bdo = hh('bdo');
exports.bgsound = hh('bgsound');
exports.big = hh('big');
exports.blink = hh('blink');
exports.blockquote = hh('blockquote');
exports.body = hh('body');
exports.br = hh('br');
exports.button = hh('button');
exports.canvas = hh('canvas');
exports.caption = hh('caption');
exports.center = hh('center');
exports.cite = hh('cite');
exports.code = hh('code');
exports.col = hh('col');
exports.colgroup = hh('colgroup');
exports.command = hh('command');
exports.content = hh('content');
exports.data = hh('data');
exports.datalist = hh('datalist');
exports.dd = hh('dd');
exports.del = hh('del');
exports.details = hh('details');
exports.dfn = hh('dfn');
exports.dialog = hh('dialog');
exports.dir = hh('dir');
exports.div = hh('div');
exports.dl = hh('dl');
exports.dt = hh('dt');
exports.element = hh('element');
exports.em = hh('em');
exports.embed = hh('embed');
exports.fieldset = hh('fieldset');
exports.figcaption = hh('figcaption');
exports.figure = hh('figure');
exports.font = hh('font');
exports.form = hh('form');
exports.footer = hh('footer');
exports.frame = hh('frame');
exports.frameset = hh('frameset');
exports.h1 = hh('h1');
exports.h2 = hh('h2');
exports.h3 = hh('h3');
exports.h4 = hh('h4');
exports.h5 = hh('h5');
exports.h6 = hh('h6');
exports.head = hh('head');
exports.header = hh('header');
exports.hgroup = hh('hgroup');
exports.hr = hh('hr');
exports.html = hh('html');
exports.i = hh('i');
exports.iframe = hh('iframe');
exports.img = hh('img');
exports.input = hh('input');
exports.ins = hh('ins');
exports.isindex = hh('isindex');
exports.kbd = hh('kbd');
exports.keygen = hh('keygen');
exports.label = hh('label');
exports.legend = hh('legend');
exports.li = hh('li');
exports.link = hh('link');
exports.listing = hh('listing');
exports.main = hh('main');
exports.map = hh('map');
exports.mark = hh('mark');
exports.marquee = hh('marquee');
exports.math = hh('math');
exports.menu = hh('menu');
exports.menuitem = hh('menuitem');
exports.meta = hh('meta');
exports.meter = hh('meter');
exports.multicol = hh('multicol');
exports.nav = hh('nav');
exports.nextid = hh('nextid');
exports.nobr = hh('nobr');
exports.noembed = hh('noembed');
exports.noframes = hh('noframes');
exports.noscript = hh('noscript');
exports.object = hh('object');
exports.ol = hh('ol');
exports.optgroup = hh('optgroup');
exports.option = hh('option');
exports.output = hh('output');
exports.p = hh('p');
exports.param = hh('param');
exports.picture = hh('picture');
exports.plaintext = hh('plaintext');
exports.pre = hh('pre');
exports.progress = hh('progress');
exports.q = hh('q');
exports.rb = hh('rb');
exports.rbc = hh('rbc');
exports.rp = hh('rp');
exports.rt = hh('rt');
exports.rtc = hh('rtc');
exports.ruby = hh('ruby');
exports.s = hh('s');
exports.samp = hh('samp');
exports.script = hh('script');
exports.section = hh('section');
exports.select = hh('select');
exports.shadow = hh('shadow');
exports.small = hh('small');
exports.source = hh('source');
exports.spacer = hh('spacer');
exports.span = hh('span');
exports.strike = hh('strike');
exports.strong = hh('strong');
exports.style = hh('style');
exports.sub = hh('sub');
exports.summary = hh('summary');
exports.sup = hh('sup');
exports.slot = hh('slot');
exports.table = hh('table');
exports.tbody = hh('tbody');
exports.td = hh('td');
exports.template = hh('template');
exports.textarea = hh('textarea');
exports.tfoot = hh('tfoot');
exports.th = hh('th');
exports.time = hh('time');
exports.title = hh('title');
exports.tr = hh('tr');
exports.track = hh('track');
exports.tt = hh('tt');
exports.u = hh('u');
exports.ul = hh('ul');
exports.video = hh('video');
exports.wbr = hh('wbr');
exports.xmp = hh('xmp');
//# sourceMappingURL=hyperscript-helpers.js.map