"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var hasCssSelector_1 = require("./hasCssSelector");
exports.querySelectorAll = function (cssSelector, vNode) {
    if (!vNode)
        return function (_vNode) { return _querySelectorAll(cssSelector, vNode); };
    return _querySelectorAll(cssSelector, vNode);
};
function _querySelectorAll(cssSelector, vNode) {
    var matches = [];
    var scope = vNode.scope;
    var children = [vNode];
    while (children.length > 0) {
        var child = children.shift();
        if (child.scope !== scope)
            continue;
        if (hasCssSelector_1.hasCssSelector(cssSelector, child))
            matches.push(child);
        if (!child.children)
            continue;
        children.push.apply(children, child.children);
    }
    return matches;
}
//# sourceMappingURL=querySelectorAll.js.map