import { ElementVNode, VNode } from './VirtualNode';
export interface Module {
    pre: PreModuleHook;
    post: PostModuleHook;
    init: InitHook;
    create: CreateHook<Element>;
    update: UpdateHook<Element>;
    remove: RemoveHook<Element>;
    destroy: DestroyHook<Element>;
    prepatch: PrepatchHook<Element>;
    postpatch: PostpatchHook<Element>;
}
export declare type PreModuleHook = (vNode: VNode) => any;
export declare type PostModuleHook = (vNode: ElementVNode) => any;
export declare type InitHook = (vNode: VNode) => any;
export declare type CreateHook<T extends Element = Element> = (vNode: ElementVNode<T>) => any;
export declare type UpdateHook<T extends Element = Element> = (formerVNode: ElementVNode<T>, vNode: ElementVNode<T>) => any;
export declare type RemoveHook<T extends Element = Element> = (vNode: ElementVNode<T>, removeElement: () => void) => any;
export declare type DestroyHook<T extends Element = Element> = (vNode: ElementVNode<T>) => any;
export declare type PrepatchHook<T extends Node = Node> = (formerVNode: VNode<T>, vNode: VNode<T>) => any;
export declare type PostpatchHook<T extends Element = Element> = (formerVNode: ElementVNode<T>, vNode: ElementVNode<T>) => any;
export declare type InsertHook<T extends Element = Element> = (vNode: ElementVNode<T>) => any;
